__author__ = 'Martin Humby 2015'


from graphs import Graph, Vertex
from queues import Queue, MinPQueue

class RoutVertex(Vertex):
    def __init__(self,  name, ID):
        Vertex.__init__(self,  name, ID)
        self.routDistance = 0

def breadthFirst(graph, start):
    graph.resetDistances(0)
    start = graph.vmap[start]           # get mapped start point
    visited = [False] * graph.vcnt      # create lookup of nodes visited
    path = []                           # the path through graph
    q = Queue()
    visited[start.ID] = True
    start.distance = 0
    q.join(start)
    while not q.empty():
        vertex = q.leave()
        print('vertex %9s' % str(vertex), end=': enqueues ')
        path.append((vertex.name, vertex.routDistance))
        vertex.edges = sorted(vertex.edges)
        for v in vertex.edges:
            if not visited[v.toVertex.ID]:
                visited[v.toVertex.ID] = True
                v.toVertex.distance = v.weight
                v.toVertex.routDistance = vertex.routDistance + v.weight
                q.join(v.toVertex)
        print(q.string())

    return path

def bestFirst(graph, start):
    graph.resetDistances(0)
    start = graph.vmap[start]            # get mapped start point
    # visited = [False] * graph.vcnt       # create lookup of nodes visited
    path = []
    pq = MinPQueue()
    start.distance = 0
    pq.join(start)
    while not pq.empty():
        vertex = pq.leave()
        print('vertex %9s' % str(vertex), end=': enqueues ')
        distance = vertex.distance
        path.append((vertex.name, vertex.routDistance))
        vertex.edges = sorted(vertex.edges)
        for p in vertex.edges:
            p.toVertex.distance = p.weight
            p.toVertex.routDistance = vertex.routDistance + p.weight
            pq.join(p.toVertex)
        print(pq)

    return path



if __name__ == '__main__':
    print('\nFrom the tree in Unit 5 Figure 5.37\n')
    g = Graph(vertexClass = RoutVertex)
    g.addEdges('S1', ('S2',16), ('S3',21), ('S4',4))
    g.addEdges('S2', ('S5',5), ('S6',12))
    g.addEdges('S3', ('S7',14), ('S8',2))
    g.addEdges('S4', ('S9',8), ('S10',3))
    g.addEdges('S5', ('S11',6))
    g.addEdges('S10', ('S12',32))
    print('Breadth first')
    print(breadthFirst(g, 'S1'))
    print('\nBest first')
    print(bestFirst(g, 'S1'))